#include <zephyr/kernel.h>
#include <zephyr/pm/pm.h>
#include <zephyr/pm/policy.h>
#include <zephyr/pm/state.h>
#include <zephyr/pm/device.h>
#include <zephyr/input/input.h>
#include <zephyr/drivers/gpio.h>

static const struct gpio_dt_spec qdec_gnd = GPIO_DT_SPEC_GET(DT_NODELABEL(qdec_gnd), gpios);
static const struct gpio_dt_spec qdec_btn_gnd = GPIO_DT_SPEC_GET(DT_NODELABEL(qdec_btn_gnd), gpios);

static void test_cb(struct input_event *evt)
{
        if (evt->code == INPUT_REL_WHEEL)
        {
                printk("z event %d\n", evt->value);
        }
        if (evt->code == INPUT_BTN_1 && evt->value == 1)
        {
                printk("short press %d\n", evt->value);
        }
        if (evt->code == INPUT_BTN_2 && evt->value == 1)
        {
                printk("long press %d\n", evt->value);
        }
}

INPUT_CALLBACK_DEFINE(NULL, test_cb);

int main(void)
{
        if (!gpio_is_ready_dt(&qdec_gnd) || !gpio_is_ready_dt(&qdec_btn_gnd))
        {
                printk("Device not ready\n");
        }

        gpio_pin_configure_dt(&qdec_gnd, GPIO_OUTPUT_LOW);
        gpio_pin_configure_dt(&qdec_btn_gnd, GPIO_OUTPUT_LOW);

        while (1)
        {
                k_sleep(K_FOREVER);
        }
}
